﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using CoboltMonitor.Laser;

namespace CoboltMonitor.Gui
{
	public partial class NEMon : Form
	{
        private LaserCommon laser;
        public delegate void UpdateSerialData(Object objSender, LaserUpdatedEvent dataReceivedEventArgs);
        
        public NEMon(LaserCommon laser)
		{
			InitializeComponent();
            this.laser = laser;
            laser.LaserUpdatedEvent += new EventHandler<LaserUpdatedEvent>(UpdateGui);
        }

		public void NewData(float neVal)
		{
			labelVAlue.Text = neVal.ToString("F3");
		}

		private void NEMon_FormClosing(object sender, FormClosingEventArgs e)
		{
			if (e.CloseReason == CloseReason.UserClosing)
				e.Cancel = true;

			Hide();
		}

		private void labelVAlue_Click(object sender, EventArgs e)
		{
			NewData(1.5436f);
		}
        private void UpdateGui(object sender, LaserUpdatedEvent e)
        {
            if (this.InvokeRequired == true)
            {
                UpdateSerialData updateHandler = new UpdateSerialData(UpdateGui);
                this.BeginInvoke(updateHandler, new Object[] { sender, e });
                return;
            }

            switch (e.CommandResponse.CommandId)
            {
                case CommandId.ReadNeVolt:
                    if (this.Visible)
                    {
                        NewData(laser.NeVolt);
                    }
                    break;
            }

        }
	}
}
