using System;
using System.Collections.Generic;
using System.Text;

namespace CoboltMonitor.Laser
{
	#region Enumerations
    /// <summary>
    /// Enum containing all commands avaliable for all supported lasers
    /// </summary>
	public enum CommandId
	{
		UnknownCommand,
		AreYouThere,

		LaserDisable,
		LaserDisable2,
        LaserDisable3,
        LaserEnable,
		LaserDiodeEnable,
		LaserDiodeEnable2,
		DisableAutostart,
		EnableAutostart,
		ForcedAutostart,
		SetAutostartState,
		GetAutostartState,
		GetAutostartState2,
		SetWarmUpDelay,
		GetWarmUpDelay,
		Disable5VDirectInputStart,
		Enable5VDirectInputStart,
		EnableDisableDirectInput,
		GetDirectInputEnableState,
		GetDirectInputEnableState2,
		SetAutostartWarmUpCurrent,
		GetAutostartWarmUpCurrent,

		SetAutostartFinalCurrent,
		GetAutostartFinalCurrent,
		GetKeySwitchState,
        GetKeySwitchState2,
        DisableKeySwitch,
		EnableKeySwitch,
		SetKeySwitchEnableState,
		GetKeySwitchEnableState,
		GetKeySwitchEnableState2,
		SetAutostartMode,
		GetAutostartMode,
		SetAutostartPower,
		GetAutostartPower,
		GetOperatingMode,
        GetAutostartProgramState,

		ClearFault,
		EnterCcMode,
        EnterCcMode2,
        EnterCpMode,
        EnterCpMode2,
        GetOperatingFault,
		GetErrorStatus,
		GetOperatingHours,
		GetOperatingHours2,
		GetOperatingSeconds,
		ClearOperatingHours,
		SetLaserCurrent,
		GetLaserCurrent,
		ReadLaserCurrent,
		ReadLaserCurrent2,
		ReadInterlockState,
		ReadInterlockStateInv,
		GetLaserEnableState,
		GetLaserEnableState2,
		GetLedStatus,
		GetLedStatus2,
		SetMaxLaserCurrent,
		GetMaxLaserCurrent,
		SetMaxLaserPower,
		GetMaxLaserPower,

		GetPidForTec1,
		GetPidForTec2,
		GetPidForTec3,
        GetPidForTec4,
        GetPidForTecld,

		SetPidForTec1,
		SetPidForTec2,
		SetPidForTec3,
        SetPidForTec4,
        SetPidForTecld,

		SetTec1Temperature,
		SetTec2Temperature,
		SetTec3Temperature,
        SetTec4Temperature,
        SetTecldTemperature,

		GetTec1Temperature,
		GetTec2Temperature,
		GetTec3Temperature,
        GetTec4Temperature,
        GetTecldTemperature,

		ReadTec1Temperature,
		ReadTec2Temperature,
		ReadTec3Temperature,
        ReadTec4Temperature,
        ReadTecldTemperature,

		SetLaserPower,
		GetLaserPower,
		ReadLaserPower,
		SetLaserPowerW,
        SetLaserPowerW2,
        GetLaserPowerW,
        GetLaserPowerW2,
        ReadLaserPowerW,

		GetSerialNumber,
		GetSerialNumber2,
        GetSerialNumber3,
        SetSerialNumber,

		DisableTec1,
		DisableTec2,
		DisableTec3,
        DisableTec4,
        DisableTecld,

		EnableTec1,
		EnableTec2,
		EnableTec3,
        EnableTec4,
        EnableTecld,

		GetTec1EnabledState,
		GetTec2EnabledState,
		GetTec3EnabledState,
        GetTec4EnabledState,
        GetTecldEnabledState,

		RunTec1,
		RunTec2,
		RunTec3,
        RunTec4,
        RunTecld,

		StopTec1,
		StopTec2,
		StopTec3,
        StopTec4,
        StopTecld,

        RunStopTec4,
        RunStopTec2,
        RunStopTec3,

		GetTec1RunState,
		GetTec2RunState,
		GetTec3RunState,
        GetTec4RunState,
        GetTecldRunState,

		ReadTec1Drive,
		ReadTec2Drive,
		ReadTec3Drive,
        ReadTec4Drive,
        ReadTecldDrive,

		ReadLaserDiodeVoltage,
		ReadPhotoDiodeVoltage,

		GetFirmwareVersion,
        GetFirmwareVersion2,
        GetFirmwareDate,
		GetFirmwareBuildDate,

		SetCalPointWattVolt,
		GetCalPointWattVolt,
		CalibrateWattsPerVolt,

		SetCalPointAmpsVolt,
		GetCalPointAmpsVolt,
		CalibrateAmpsPerVolt,

		SetTec1MaxDrive,
		SetTec2MaxDrive,
		SetTec3MaxDrive,
        SetTec4MaxDrive,
        SetTecldMaxDrive,

		GetTec1MaxDrive,
		GetTec2MaxDrive,
		GetTec3MaxDrive,
        GetTec4MaxDrive,
        GetTecldMaxDrive,

		SetTecTimeout,
		GetTecTimeout,
		GetTecDeltaTemp,
		SetTecDeltaTemp,

		ReadRmsVoltage,
		ReadRmsPercent,
		ReadNeVolt,

		EnableS3,
		DisableS3,
		GetS3,

		ReadAll,
		ReadAllSetPoints,

		SetIpLogCurrent,
        ReadIpLogCurr1,
        ReadIpLogCurr2,
		Abort,
		Restart,

		SetLaserPid,
		GetLaserPid,

		SysRes,

		EnableDebugMessages,

		TestCmd,
		GetIo,

		CalibrateLdCurr,
		EnableCalibrateLdCurr,
		GetCalibrateLdCurr,

		SetCmdName,
		GetCmdName,

		SetAdChannels,
		GetAdChannels,

		EnableTeclLdThresholdCalibration,
		ReadTecLdThreshold,
		SetTecLdThreshold,
		GetTecLdThreshold,
        GetTecLdDefaultThreshold,

        WriteFactoryDefaultLaserInfo,

        //gen681
        ReadTec1Ntc,
        ReadTec2Ntc,
        ReadTec3Ntc,
        ReadTecldNtc,

        ReadTec1Curr,
        ReadTec2Curr,
        ReadTec3Curr,
        ReadTecldCurr,

        WriteTec1Ctrl,
        WriteTec2Ctrl,
        WriteTec3Ctrl,
        WriteTecldCtrl,

        WriteTEC1ENA,
        WriteTEC2ENA,
        WriteTEC3ENA,
        WriteTECldENA,

        ReadBoardTemp,
		ReadBasePlateTemp,
		SetModulationEnabledState,
		GetModulationEnabledState,
		SetDigitalModulationEnabledState,
		GetDigitalModulationEnabledState,
		//GetDigitalModulationDetect,
		SetAnalogModulationEnabledState,
		GetAnalogModulationEnabledState,
		SetAnalogLowImpedanceState,
		GetAnalogLowImpedanceState,
		//SetRemoteOnEnabledState,
		//GetRemoteOnEnabledState,
		GetRemoteOnDetect,

		ReadSpare,

		// Commands to manage 10V DC/DC converter.
		Set10VCtr,
		Get10VCtr,

		Set10VEna,
		Get10VEna,

		// Commands to manage second channel laser drive.
		Set2ChDrv,
		Get2ChDrv,

		// Commands to query CCLIM levels.
		GetCcLim1,
		GetCcLim2,

		// Commands to manage Laser DAC settings for analog modulation.
		SetAcLevAmod1,
		GetAcLevAmod1,

		SetAcLevAmod2,
		GetAcLevAmod2,

		// Command to query laser DAC level for digital modulation.
		GetAcLevDmod,

		// Command to query laser drive DAC value.
		GetDac,

		SetPhotoDiodeDarkVal,
		GetPhotoDiodeDarkVal,

		// Commands to enter/exit test mode.
		EnterTestMode,
		ExitTestMode,

		// Commands to read various input signals in test mode.
		ReadDCSEN,
		ReadPWRMON,
		ReadHFDET,
		ReadREMON,
		ReadBTMP,
		Read5VIN,
		ReadKEYINT,
		ReadNTCTE,
		ReadNTCSP,
		ReadNTCBP,
		ReadLDREM,
		ReadTECFAULT,

		// Commands to set various output signals in test mode.
		Write10VENA,
		WriteTECENA,
		WriteAMODDIS,
		WriteAMOD50R,
		WriteACLEV,
		WriteCCLIM,
		WriteBIAS,
		Write10VCTR,
		WriteTECCTRL,
		WriteSPARE,

        //MLD tec commands
        GetPidForTec,
        SetPidForTec,
        SetTecTemperature,
        GetTecTemperature,
        ReadTecTemperature,
        DisableTec,
        EnableTec,
        GetTecEnabledState,
        RunTec,
        StopTec,
        GetTecRunState,
        ReadTecDrive,
        GetTecMaxDrive,

        SetLaserModPower,
        GetLaserModPower,

        EnterModMode,
        EnterOnOffMode,
        ExitOnOffMode,
       
        GetLaserModel,
	    SetLaserModel,

        GetDriverNumber,
	    SetDriverNumber,

        SetTec1Offset,
        SetTec2Offset,
        SetTec3Offset,
        SetTecLdOffset,

        ReadAllJSON,
	    ReadAllSetPointsJSON,

        SetBaud,
        FirmwareUpdate,

		SpecialCommand
	};
	#endregion

    /// <summary>
    /// A class containing information of a laser command. Such as command name, if the user needs to be logged in or not.
    /// </summary>
    public class CommandInfo
    {
        #region Private variables
        private string _name;			// command name, as sent via RS232
        private string _info;			// short command description
        private bool _needsAuth;		// true if command needs authorization to be performed (user must be logged in)
        private bool _secretHelp;		// true if command should be hidden from help and intellisense unless logged in
        #endregion

        #region Properties
        public string Name
        {
            get { return _name; }
        }

        public string Info
        {
            get { return _info; }
        }

        public bool NeedsAuth
        {
            get { return _needsAuth; }
        }

        public bool SecretHelp
        {
            get { return _secretHelp; }
        }
        #endregion

        #region Constructors
        public CommandInfo(string name, string info, bool auth, bool help)
        {
            _name = name;
            _info = info;
            _needsAuth = auth;
            _secretHelp = help;
        }
        #endregion
    }
    /// <summary>
	/// Objects of this class holds the command and response strings
	/// sent to/from the Cobolt Laser Driver.
	/// </summary>
	public class CommandResponse
	{
		#region Private variables
        private Object _sender;
        private CommandId _commandId;
        private string _args;
        private string _resp;
        private string _sendString;
		#endregion

		#region Constructors
        public CommandResponse(CommandId commandid, string args, string sendstring)
        {
            _sender = null;
            _commandId = commandid;
            _args = args;
            _resp = "";
            _sendString = sendstring;
        }

        public CommandResponse(Object id, CommandId commandid, string args, string sendstring)
		{
			_sender = id;
            _commandId = commandid;
			_args = args;
			_resp = "";
            _sendString = sendstring;
        }
		#endregion

		#region Properties
        public Object Sender
		{
			get { return _sender; }
			set { _sender = value; }
		}

        public CommandId CommandId
		{
            get { return _commandId; }
            set { _commandId = value; }
		}

		public string Args
		{
			get { return _args; }
			set { _args = value; }
		}

		public string Resp
		{
			get { return _resp; }
			set { _resp = value; }
		}
        public string Sendstring
        {
            get { return _sendString; }
        }
        #endregion
	}
}
