﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using CoboltMonitor.Gui;
using CoboltMonitor.Laser;
using System.IO;

namespace CoboltMonitorMLD.Gui
{
    public partial class ParLogMLD : ParLog
    {
        public ParLogMLD(LaserCommon laser) : base(laser)
        {
        }

        protected override void WriteCSV(StreamWriter str)
        {
            foreach (ParLogData d in _data)
            {

                str.Write(d.LdCurr + ";" + d.LdPow);
                foreach (Tec t in d.Tecs)
                {
                    str.Write(";" + t.Temp + ";" + t.Drive);
                }
                str.Write(Environment.NewLine);
            }
        }

        protected override void NewLogData(object sender, LaserUpdatedEvent e)
        {
            Tec[] tecs = laser.GetTecs();
            switch (e.CommandResponse.CommandId)
            {
                case CommandId.ReadAll:
                    ParLogData logData = new ParLogData(tecs.Length);
                    for (int i = 0; i < logData.Tecs.Length; ++i)
                    {
                        logData.Tecs[i] = tecs[i];
                    }

                    // Laser Current, Power
                    logData.LdCurr = laser.LaserCurrent;
                    logData.LdPow = laser.LaserPower;

                    CollectData(logData);

                    break;
            }
        }
    }
}
